unit TMS_PDFDemo_01;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls,
  AdvCustomControl, AdvCustomScrollControl, AdvPDFViewer;

type
  Tfm_PDFViewer = class(TForm)
    pdf_Viewer: TAdvPDFViewer;
    bt_ScrollUp: TButton;
    bt_ScrollDn: TButton;
    bt_OpenPDF: TButton;
    pa_LoadPDF: TPanel;
    dlg_Open: TOpenDialog;
    ti_ScrollPDF: TTimer;
    la_AnzScrollPos: TLabel;
    la_AnzScrollPage: TLabel;
    pa_ButtonRight: TPanel;
    procedure bt_OpenPDFClick(Sender: TObject);
    procedure ti_ScrollPDFTimer(Sender: TObject);
    procedure bt_ScrollMouseLeave(Sender: TObject);
    procedure bt_ScrollMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_ScrollDnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_ScrollUpMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pdf_ViewerLoaded(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  fm_PDFViewer: Tfm_PDFViewer;

  pdf_IncDecAktiv : integer;
  pdf_FilenameBak : string;

implementation

{$R *.dfm}



procedure Tfm_PDFViewer.bt_OpenPDFClick(Sender: TObject);
begin
  pa_LoadPDF.Visible       := true;

  dlg_Open.Execute;
  pdf_Viewer.FileName      := dlg_Open.FileName;

  if pdf_FilenameBak = pdf_FilenameBak then
    pa_LoadPDF.Visible     := false;

  pdf_FilenameBak          := pdf_Viewer.FileName;
end;

procedure Tfm_PDFViewer.bt_ScrollMouseLeave(Sender: TObject);
begin
  pdf_IncDecAktiv          := 0;

  ti_ScrollPDF.Enabled     := false;
  ti_ScrollPDF.Interval    := 500;
end;

procedure Tfm_PDFViewer.bt_ScrollMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  bt_ScrollMouseLeave(Sender);
end;

procedure Tfm_PDFViewer.bt_ScrollUpMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pdf_IncDecAktiv          := -50;

  ti_ScrollPDF.Enabled     := true;
  ti_ScrollPDFTimer(Sender);
end;

procedure Tfm_PDFViewer.pdf_ViewerLoaded(Sender: TObject);
begin
  pa_LoadPDF.Visible       := false;
end;

procedure Tfm_PDFViewer.bt_ScrollDnMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  pdf_IncDecAktiv          := 50;

  ti_ScrollPDF.Enabled     := true;
  ti_ScrollPDFTimer(Sender);
end;


procedure Tfm_PDFViewer.ti_ScrollPDFTimer(Sender: TObject);
var
  tmScrollPos              : double;
begin
  if pdf_IncDecAktiv <> 0 then begin
    tmScrollPos            := pdf_Viewer.GetVerticalScrollPosition;
    tmScrollPos            := tmScrollPos + pdf_IncDecAktiv;

    if (tmScrollPos >= pdf_Viewer.GetVerticalScrollMax) then begin
      tmScrollPos          := pdf_Viewer.GetVerticalScrollMax;
//      bt_ScrollMouseLeave(Sender); can better show the effect
    end;
    if (tmScrollPos <= 0) then begin
      tmScrollPos          := 0;
//      bt_ScrollMouseLeave(Sender); can better show the effect
    end;

    if (pdf_Viewer.VerticalScrollBar.Position <> tmScrollPos) then
      pdf_Viewer.VerticalScrollBar.Position := Trunc(tmScrollPos);
  end;

  if ti_ScrollPDF.Interval > 50 then
    ti_ScrollPDF.Interval := Round (ti_ScrollPDF.Interval / 1.5);
  if ti_ScrollPDF.Interval < 50 then
    ti_ScrollPDF.Interval := 50;

  la_AnzScrollPos.Caption      := IntToStr(pdf_Viewer.VerticalScrollBar.Position) + '/' + IntToStr(Trunc(pdf_Viewer.GetVerticalScrollMax));
  la_AnzScrollPage.Caption     := IntToStr(pdf_Viewer.PageIndex+1) + '/' + IntToStr(Trunc(pdf_Viewer.PageCount));
end;

end.
